Index: /trunk/sources/HeuristicLab.Core/3.3/Collections/VariableCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Collections/VariableCollection.cs	(revision 3390)
+++ /trunk/sources/HeuristicLab.Core/3.3/Collections/VariableCollection.cs	(revision 3390)
@@ -0,0 +1,47 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Core {
+  [StorableClass]
+  [Item("VariableCollection", "Represents a collection of variables.")]
+  public sealed class VariableCollection : NamedItemCollection<IVariable> {
+    public VariableCollection() : base() { }
+    public VariableCollection(int capacity) : base(capacity) { }
+    public VariableCollection(IEnumerable<IVariable> collection) : base(collection) { }
+    [StorableConstructor]
+    private VariableCollection(bool deserializing) : base(deserializing) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      VariableCollection clone = new VariableCollection();
+      cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
+      foreach (string key in dict.Keys)
+        clone.dict.Add(key, (IVariable)cloner.Clone(dict[key]));
+      clone.Initialize();
+      return clone;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 3389)
+++ /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 3390)
@@ -102,4 +102,31 @@
     <Compile Include="Attributes\CreatableAttribute.cs" />
     <None Include="HeuristicLabCorePlugin.cs.frame" />
+    <Compile Include="Collections\ReadOnlyItemDictionary.cs" />
+    <Compile Include="Collections\ItemDictionary.cs" />
+    <Compile Include="Collections\ReadOnlyKeyedItemCollection.cs" />
+    <Compile Include="Collections\KeyedItemCollection.cs" />
+    <Compile Include="Collections\ReadOnlyItemSet.cs" />
+    <Compile Include="Collections\ReadOnlyItemList.cs" />
+    <Compile Include="Collections\ReadOnlyItemArray.cs" />
+    <Compile Include="Collections\ReadOnlyItemCollection.cs" />
+    <Compile Include="Collections\ItemArray.cs" />
+    <Compile Include="Collections\ItemCollection.cs" />
+    <Compile Include="Collections\ItemList.cs" />
+    <Compile Include="Collections\ItemSet.cs" />
+    <Compile Include="Collections\NamedItemCollection.cs" />
+    <Compile Include="Collections\OperationCollection.cs" />
+    <Compile Include="Collections\OperatorCollection.cs" />
+    <Compile Include="Collections\OperatorList.cs" />
+    <Compile Include="Collections\OperatorSet.cs" />
+    <Compile Include="Collections\ParameterCollection.cs" />
+    <Compile Include="Collections\ScopeList.cs" />
+    <Compile Include="Collections\ValueParameterCollection.cs" />
+    <Compile Include="Collections\VariableCollection.cs" />
+    <Compile Include="Interfaces\IKeyedItemCollection.cs" />
+    <Compile Include="Interfaces\IItemList.cs" />
+    <Compile Include="Interfaces\IItemSet.cs" />
+    <Compile Include="Interfaces\IItemDictionary.cs" />
+    <Compile Include="Interfaces\IItemArray.cs" />
+    <Compile Include="Interfaces\IItemCollection.cs" />
     <Compile Include="Log.cs" />
     <Compile Include="Executable.cs" />
@@ -112,11 +139,8 @@
     <Compile Include="Interfaces\IExecutionContext.cs" />
     <Compile Include="Interfaces\IOperation.cs" />
-    <Compile Include="OperationCollection.cs" />
     <Compile Include="ParameterizedNamedItem.cs" />
-    <Compile Include="ValueParameterCollection.cs" />
     <Compile Include="Interfaces\IValueLookupParameter.cs" />
     <Compile Include="Interfaces\IValueParameter.cs" />
     <Compile Include="Interfaces\ILookupParameter.cs" />
-    <Compile Include="ItemArray.cs" />
     <Compile Include="Engine.cs" />
     <Compile Include="Interfaces\IScope.cs" />
@@ -126,18 +150,8 @@
     <Compile Include="OperatorGraph.cs" />
     <Compile Include="Interfaces\IParameter.cs" />
-    <Compile Include="OperatorCollection.cs" />
-    <Compile Include="ItemCollection.cs" />
-    <Compile Include="OperatorSet.cs" />
-    <Compile Include="ItemSet.cs" />
-    <Compile Include="ItemList.cs" />
     <Compile Include="Interfaces\IEngine.cs">
       <SubType>Code</SubType>
     </Compile>
     <Compile Include="ExecutionContext.cs" />
-    <Compile Include="OperatorList.cs" />
-    <Compile Include="ParameterCollection.cs" />
-    <Compile Include="VariableCollection.cs" />
-    <Compile Include="ScopeList.cs" />
-    <Compile Include="NamedItemCollection.cs" />
     <Compile Include="Interfaces\INamedItem.cs" />
     <Compile Include="Interfaces\IItem.cs" />
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemArray.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemArray.cs	(revision 3390)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemArray.cs	(revision 3390)
@@ -0,0 +1,26 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  public interface IItemArray<T> : IObservableArray<T>, IItem where T : class, IItem { }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemCollection.cs	(revision 3390)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemCollection.cs	(revision 3390)
@@ -0,0 +1,26 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  public interface IItemCollection<T> : IObservableCollection<T>, IItem where T : class, IItem { }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemDictionary.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemDictionary.cs	(revision 3390)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemDictionary.cs	(revision 3390)
@@ -0,0 +1,27 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  public interface IItemDictionary<TKey, TValue> : IObservableDictionary<TKey, TValue>, IItem where TKey : class, IItem where TValue : class, IItem { }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemList.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemList.cs	(revision 3390)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemList.cs	(revision 3390)
@@ -0,0 +1,26 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  public interface IItemList<T> : IObservableList<T>, IItemCollection<T>, IItem where T : class, IItem { }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemSet.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemSet.cs	(revision 3390)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItemSet.cs	(revision 3390)
@@ -0,0 +1,26 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  public interface IItemSet<T> : IObservableSet<T>, IItemCollection<T>, IItem where T : class, IItem { }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IKeyedItemCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IKeyedItemCollection.cs	(revision 3390)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IKeyedItemCollection.cs	(revision 3390)
@@ -0,0 +1,26 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  public interface IKeyedItemCollection<TKey, TItem> : IObservableKeyedCollection<TKey, TItem>, IItemCollection<TItem>, IItem where TItem : class, IItem { }
+}
